import "timer.jsx";
import "js/web.jsx";

class _Main {
  async static function main(args : string[]) : void {
    // ----------------------------
    // code using await
    // ----------------------------

    // class AsyncTask.<RetunrTypeOfAsyncOperator, ResultTypeOfYieldReturn>;
    var asyncTask : AsyncTask.<int, void> = async Timer.setTimeout(() -> {
      yield return;
    }, 1000);

    log asyncTask.value; // timer id of setTimeout()
    await asyncTask;

    log "Hello after setTimeout";

    // with values

    var xhr = new XMLHttpRequest();
    var responseText = await xhr.addEventListener("complete", (event) -> {
      yield return xhr.responseText;
    });

    log responseText;

    // ----------------------------
    // compiled into:
    // ----------------------------

    Timer.setTimeout(() {
      // <<yeild return here>>
      log "Hello after setTimeout";

      var xhr = new XMLHttpRequest();
      xhr.addEventListener("complete", (event) -> {
        // <<yield return xhr.responseText here>>
        var responseText = xhr.responseText;

        log responseText;
      });
    });

  }
}

// vim: set tabstop=2 shiftwidth=2 expandtab:

